/* Kompilator konfiguraku na web
 * (c)16.10.1999 by Marek Zelem
 */

#include <mmm/compiler.h>
#include <mmm/dynamic.h>

enum {
	Lsekcia=T|0x0100,
	Lsub,
	Lid,
	Lstr,
	Lfile,
	Lvar,
	Lhidden
};
enum {
	LS_start=LS|0x0100,
	LS_ident,
	LS_string,
	LS_file,
	LS_var,
	LS_comment_line
};
enum {
	START=N,
	BLOK1,
	BLOK2,
	P,
	P1,
	J,
	H,
	HH,
	H1
};
enum {
	oSNEW=O,
	oSEND,
	oSSTR,
	oNAM,
	oSTR,
	oCPSTR,
	oFSTR,
	oHIDB,
	oHIDE,
	oFILTERVAL,
	oADDVAL,
	oVAL
};
enum {
	Evzor=E|0x0100,
	Euprav_vzor,
	Efile,
};
enum {
	Wvzor=W|0x0100,
	Wsecnoefe,
	Wunused,
};

#define	SET_UNUSED(str)	((str)[strlen(str)+1]=0)
#define	SET_USED(str)	((str)[strlen(str)+1]=1)
#define	IS_USED(str)	((str)[strlen(str)+1])

#define	M_INCL	0x80
typedef struct mnu_s	{
	struct mnu_s	*next,*last_sub,*sub;
	char		*nazov;
	char		*popis;
	char		*subor;
	int		typ;
			} mnu_t;

typedef struct	{
	char		*nazov;
	dfield_t	*p;
	int		aktual;
	unsigned long	data;
	mnu_t		*menu;
	ddata_t		*hidden;
		} sekcia_t;

typedef struct	{
	struct compiler_out_class meta;
	struct compiler_err_class *err;
	dfifo_t	*zasobnik;
	sekcia_t sekcia;
	int	hidden;
		} out_t;

extern compiler_class_t *compiler;
extern struct compiler_err_class err_tab;
extern struct compiler_preprocessor_class *prep;

int warning( char *format, ... );
int error( char *format, ... );

char *file2str( char *filename );
int data2file( char *fn, char *data );
int linkfile( char *fn, char *from );
int copyfile( char *fn, char *from );
char *filter( char *in, char *prog, char *arg );

struct compiler_out_class *out_create( compiler_class_t *c );

int najdi_prem( dfield_t *p, char *name );

/* nr - 1-n */
char *get_value( dfield_t *p, char *name, int nr, int *next );
char *get_val( sekcia_t *stack, int stacksize, char *name, int nr, int *next );
char *spracuj_sekciu( out_t *o );
int del_value( dfield_t *p, char *name );

char *uprav_vzor( char *vzor, sekcia_t *s, sekcia_t *stack, int stacksize );
char *uprav_retazec( int m, char *vzor, sekcia_t *s, sekcia_t *stack, int stacksize, char *n1, char *v1 );

mnu_t *new_menu( void );
void del_menu( mnu_t *m );
void add_submenu( mnu_t *m, mnu_t *sub );
void add_nsubmenu( mnu_t *m, int n, char *popis );
char *sprav_menu( sekcia_t *s );

extern char *text_filter;
extern char *text_exec;

#define Free(x)	do {printf("Free: %p\n",(x)); fflush(stdout); free(x); printf("Free: PO\n"); fflush(stdout);} while(0)

